package org.netkernel.json.core.endpoint;

import org.json.JSONArray;
import org.json.JSONObject;
import org.netkernel.json.core.rep.DeterminateJSON;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer1.representation.IDeterminateStringRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class JSONParser extends StandardTransreptorImpl
{

	public JSONParser()
	{	this.declareThreadSafe();
		this.declareToRepresentation(JSONObject.class);
		this.declareToRepresentation(JSONArray.class);
		this.declareToRepresentation(DeterminateJSON.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	IDeterminateStringRepresentation s=context.sourcePrimary(IDeterminateStringRepresentation.class);
		Class c=context.getThisRequest().getRepresentationClass();
		Object result=null;
		if(c.isAssignableFrom(JSONObject.class))
		{	result=new JSONObject(s.getString());
		}
		else if(c.isAssignableFrom(JSONArray.class))
		{	result=new JSONArray(s.getString());
		}
		else
		{	try
			{	result=new DeterminateJSON(new JSONObject(s.getString()));
			}
			catch(Exception e)
			{	try
				{	result=new DeterminateJSON(new JSONArray(s.getString()));
				}
				catch(Exception ee)
				{	context.logRaw(INKFRequestContext.LEVEL_SEVERE, ee.toString());
					throw e;
				}
			}
		}
		context.createResponseFrom(result);
	}
}
