package org.netkernel.json.core.endpoint;

import org.json.JSONObject;
import org.json.XML;
import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class JSONToXML extends StandardAccessorImpl
{
	public JSONToXML()
	{	this.declareThreadSafe();
		declareArgument(new SourcedArgumentMetaImpl("operand","input JSON Object",null,new Class[]{JSONObject.class}));
		declareArgument(new SourcedArgumentMetaImpl("operator","configuration",null,new Class[]{IHDSNode.class}));
		declareSourceRepresentation(String.class);
	}
	
	public void onSource(INKFRequestContext context) throws Exception
	{	
		JSONObject jo=context.source("arg:operand", JSONObject.class);
		String jx=XML.toString(jo);
		
		boolean addRootElement=false;
		if (context.getThisRequest().argumentExists("operator"))
		{	IHDSNode operator=context.source("arg:operator",IHDSNode.class);
			Object addRootElementString=operator.getFirstValue("/*/addRootElement");
			if (addRootElementString!=null && (addRootElementString.equals(Boolean.TRUE) || addRootElementString.equals("true")))
			{	addRootElement=true;
			}
		}
		if (addRootElement)
		{	StringBuilder sb=new StringBuilder(jx.length()+15);
			sb.append("<json>");
			sb.append(jx);
			sb.append("</json>");
			jx=sb.toString();
		}
		
		INKFResponse resp=context.createResponseFrom(jx);
		resp.setMimeType("text/xml");
	}
}
